#include <cstdio>
#include <cstdlib>
#include <cstring>
using namespace std;

#define prekazok(r,c) (PS[(r)+R2][(c)+C2] - PS[r][(c)+C2] - PS[(r)+R2][c] + PS[r][c])

int R1,C1,R2,C2,M,PS[2048][2048];
char ourwalk[2048*2048], theirwalk[2048*2048];
char ERROR[] = "Santa je chudak.";

int main(int argc, char **argv) {
    if (argc!=4) { printf("usage: checker input correct_output their_output\n"); exit(2); }
    FILE *fin=fopen(argv[1],"r");
    FILE *four=fopen(argv[2],"r");
    FILE *ftheir=fopen(argv[3],"r");
    if (!fin || !four || !ftheir) { printf("one or more files not found\n"); exit(2); }
    fscanf(fin,"%d%d%d%d%d",&R1,&C1,&R2,&C2,&M);
    for (int r=0; r<R1; ++r) { 
        char row[2048]; fscanf(fin,"%s",row);
        for (int c=0; c<C1; ++c) PS[r+1][c+1] = PS[r][c+1] + PS[r+1][c] - PS[r][c] + (row[c]=='X'?1:0);
    }
    fgets(ourwalk,sizeof(ourwalk),four);
    fgets(theirwalk,sizeof(theirwalk),ftheir);
    // strip trailing whitespace
    int ol = strlen(ourwalk), tl = strlen(theirwalk);
    while (ol>0 && ourwalk[ol-1]<=32) { ourwalk[ol-1]=0; --ol; }
    while (tl>0 && theirwalk[tl-1]<=32) { theirwalk[tl-1]=0; --tl; }
    if (!strcmp(ourwalk,ERROR) && !strcmp(theirwalk,ERROR)) { printf("OK\n"); exit(0); }
    if (!strcmp(ourwalk,ERROR)) { printf("Cesta neexistuje ale program nepoda spravnu hlasku.\n"); exit(1); }
    if (!strcmp(theirwalk,ERROR)) { printf("Cesta existuje ale program ju nenajde.\n"); exit(1); }
    for (int i=0; i<tl; ++i) if (theirwalk[i]!='S' && theirwalk[i]!='J' && theirwalk[i]!='V' && theirwalk[i]!='Z') { printf("Vystup obsahuje ine pismeno ako SJVZ.\n"); exit(1); }
    if (tl > ol) { printf("Dlzka najdenej cesty nie je najkratsia mozna.\n"); exit(1); }
    int r=0, c=0;
    for (int i=0; i<tl; ++i) {
        if (theirwalk[i]=='S') --r;
        if (theirwalk[i]=='J') ++r;
        if (theirwalk[i]=='Z') --c;
        if (theirwalk[i]=='V') ++c;
        if (r<0 || c<0 || r+R2 > R1 || c+C2 > C1) { printf("Navrhovana cesta opustila miestnost.\n"); exit(1); }
        if (prekazok(r,c) > M) { printf("Navrhovana cesta narazila na privela prekazok.\n"); exit(1); }
    }
    if (r+R2 != R1 || c+C2 != C1) { printf("Navrhovana cesta neskoncila v protilahlom rohu.\n"); exit(1); }
    if (tl < ol) { printf("NASIEL LEPSIU CESTU AKO MY -- NIECO JE ZLE.\n"); exit(2); }
    printf("OK\n"); exit(0);
}
