#include <iostream>
#include <sstream>
#include <utility>
#include <vector>
#include <string>
#include <queue>

using namespace std;

string ERROR = "Santa je chudak.";
int dr[]={-1,0,1,0}, dc[]={0,-1,0,1}; char dt[]={'S','Z','J','V'};

int R1, C1, R2, C2, M;
vector< vector<int> > PS;

inline int prekazok(int r, int c) {
    int answer = 0;
    for (int kr=r; kr<r+R2; ++kr) answer += PS[kr][c+C2] - PS[kr][c];
    return answer;
}

int main() {
    string line;
    getline(cin,line); stringstream(line) >> R1 >> C1 >> R2 >> C2 >> M;

    PS.resize(R1,vector<int>(C1+1,0)); // prefixove sucty vstupu
    for (int r=0; r<R1; ++r) {
        getline(cin,line);
        for (int c=0; c<C1; ++c) PS[r][c+1] = PS[r][c] + (line[c]=='X'?1:0);
    }

    vector< vector<int> > dist(R1,vector<int>(C1,123456789)), from(R1,vector<int>(C1));
    dist[0][0] = 0; from[0][0] = -1;
    queue< pair<int,int> > Q; Q.push( pair<int,int>(0,0) );
    while (!Q.empty()) {
        int r,c;
		r = Q.front().first;
		c = Q.front().second;
		Q.pop();
        for (int d=0; d<=3; d++) {
            int nr=r+dr[d], nc=c+dc[d];
            if (nr<0 || nc<0 || nr+R2>R1 || nc+C2>C1) continue;
            if (prekazok(nr,nc) > M || dist[nr][nc] <= dist[r][c]+1) continue;
            dist[nr][nc] = dist[r][c]+1;
            from[nr][nc] = d;
            Q.push( pair<int,int>(nr,nc) );
        }
    }

    if (dist[R1-R2][C1-C2]==123456789) { cout << ERROR << endl; return 0; }
    string cesta = "";
    int r=R1-R2, c=C1-C2;
    while (r+c>0) { int d=from[r][c]; cesta += dt[d]; int nr=r-dr[d], nc=c-dc[d]; r=nr; c=nc; }
    cout << string(cesta.rbegin(),cesta.rend()) << endl;
}
